// RSSMU_ARB_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMU_ARB_Example.h"
#include "RSSMU_ARB_ExampleDlg.h"
#include "Resource.h"
#include "rssmu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_ARB_ExampleDlg dialog

CRSSMU_ARB_ExampleDlg::CRSSMU_ARB_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMU_ARB_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMU_ARB_ExampleDlg)
	m_ARBState = FALSE;
	m_Query = TRUE;
	m_Reset = TRUE;
	m_ResName = _T("GPIB::28");
	m_RFFreq = 1.0E9;
	m_RFLevel = -30.0;
	m_RFState = FALSE;
	m_Waveform = _T("test.wv");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSMU_ARB_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMU_ARB_ExampleDlg)
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Check(pDX, IDC_ARB_STATE, m_ARBState);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_Text(pDX, IDC_RF_FREQ, m_RFFreq);
	DDX_Text(pDX, IDC_RF_LEVEL, m_RFLevel);
	DDX_Check(pDX, IDC_RF_STATE, m_RFState);
	DDX_Text(pDX, IDC_WAVEFORM, m_Waveform);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMU_ARB_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSMU_ARB_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDApply, OnApply)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_ARB_ExampleDlg message handlers

BOOL CRSSMU_ARB_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
//	*_getdcwd

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSMU_ARB_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSMU_ARB_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSMU_ARB_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSMU_ARB_ExampleDlg::OnApply() 
{
	ViStatus	rssmu_status;
	ViSession	instrSession;
	char		buffer[512];
	ViChar		wave_path[256],
				full_path[256],
				idn[256],
				*p2buf;

	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	UpdateData();
	
	strcpy(full_path, m_Waveform);
	strcpy(wave_path, m_Waveform);

	if (p2buf = strrchr (wave_path, '\\')) strcpy(wave_path, p2buf+1);

    /* Initialize the driver */
	rssmu_status = rssmu_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &instrSession);
	if (rssmu_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}
    
    FT_CHECKERR (rssmu_IdentificationQuery (instrSession, idn), "rssmu_IdentificationQuery");
    if (strstr (idn, "SMBV") != NULL)
        sprintf (wave_path, "/hdd/%s", m_Waveform);

	FT_CHECKERR( rssmu_writeFromFile (instrSession, full_path, wave_path), 
												"rssmu_writeFromFile");
	FT_CHECKERR (rssmu_WaittoContinue(instrSession),"rssmu_WaitToConttinue");
	FT_CHECKERR (rssmu_ARBWaveformSelect (instrSession, RSSMU_PATH_A, wave_path), "rssmu_ARBWaveformSelect");
	FT_CHECKERR (rssmu_SetARBState(instrSession, RSSMU_PATH_A, m_ARBState), "rssmu_SetARBState");
	FT_CHECKERR (rssmu_SetRFAmplitude (instrSession, RSSMU_PATH_A, m_RFLevel), "rssmu_SetRFAmplitude");
	FT_CHECKERR (rssmu_SetRFFrequency (instrSession, RSSMU_PATH_A, m_RFFreq), "rssmu_SetRFFrequency");
	FT_CHECKERR (rssmu_SetOutputState (instrSession, RSSMU_PATH_A, m_RFState), "rssmu_SetOutputState");
	rssmu_close(instrSession);
}

void CRSSMU_ARB_ExampleDlg::OnBrowse() 
{
	CString file;
	CFileDialog fileDlg( TRUE, "*.wv", NULL, OFN_ALLOWMULTISELECT | OFN_HIDEREADONLY, "Waveform File (*.wv)|*.wv||", this);

	if ( fileDlg.DoModal() == IDOK)
	{
		file = fileDlg.GetPathName();
	}
	m_Waveform = file;
	UpdateData(false);
	
}
