// RSSMU_ARB_ExampleDlg.h : header file
//

#if !defined(AFX_RSSMU_ARB_EXAMPLEDLG_H__1F252038_DF1B_4D5E_984C_83F29F8E01D3__INCLUDED_)
#define AFX_RSSMU_ARB_EXAMPLEDLG_H__1F252038_DF1B_4D5E_984C_83F29F8E01D3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* Error check macro for driver functions */

#define FT_CHECKERR(fcal, err) if ((rssmu_status = fcal) < 0){\
								 rssmu_close(instrSession);\
        						 sprintf (buffer, "Error: %ld, %s", rssmu_status, err);\
        						 AfxMessageBox (buffer, MB_OK);\
        						 return;\
        						 }

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_ARB_ExampleDlg dialog

class CRSSMU_ARB_ExampleDlg : public CDialog
{
// Construction
public:
	CRSSMU_ARB_ExampleDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSSMU_ARB_ExampleDlg)
	enum { IDD = IDD_RSSMU_ARB_EXAMPLE_DIALOG };
	CButton	m_Browse;
	BOOL	m_ARBState;
	BOOL	m_Query;
	BOOL	m_Reset;
	CString	m_ResName;
	double	m_RFFreq;
	double	m_RFLevel;
	BOOL	m_RFState;
	CString	m_Waveform;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSSMU_ARB_ExampleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRSSMU_ARB_ExampleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnApply();
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSSMU_ARB_EXAMPLEDLG_H__1F252038_DF1B_4D5E_984C_83F29F8E01D3__INCLUDED_)
